/***************************************************************************
 *   Copyright (C) 2005 by Teppei Tamra   *
 *   TAM(tam-t@par.odn.ne.jp)   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef NAGISA_H
#define NAGISA_H

#include <qwidget.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qlabel.h>

class nagisa: public QWidget
{
    Q_OBJECT

public:
    nagisa(const QString &xml = 0);
    ~nagisa();
    void createKeyboaed(const QString &xml);

public slots:
    void sendKeyPressEvent(const QString &e);
    void sendKeyReleaseEvent(const QString &e);
protected:
    virtual void mousePressEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *e);
    virtual void mouseMoveEvent(QMouseEvent *e);
protected:
    bool mousePress;
    int mouseX;
    int mouseY;
    QWidget *contents;
    QLabel *status;
    QToolButton *scaleButton;
    QPopupMenu *menu;
    int menu_scale;
    int menu_connect;
    int menu_exit;
    int id;
    int size;
    QString keytable;

protected slots:
    void scale();
    void connectToScim();
    void updateStatus(const QString &s);
    void enlarge();
    void shrink();
};


#endif
