/***************************************************************************
 *   Copyright (C) 2005 by Teppei Tamra   *
 *   TAM(tam-t@par.odn.ne.jp)   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NAGISAKEYBOARD_H
#define NAGISAKEYBOARD_H

#include <qwidget.h>
#include <qlayout.h>
#include <qvaluelist.h>
#include <keybutton.h>
#include <qdom.h>

/**
@author Teppei Tamra
*/
class NagisaKeyboard : public QWidget
{
Q_OBJECT
public:
    NagisaKeyboard(QWidget *parent = 0, const char *name = 0);
    NagisaKeyboard(const QString &xml, QWidget *parent = 0, const char *name = 0);
    ~NagisaKeyboard();
    static const QStringList uniq(const QStringList &list);
protected:
    QGridLayout *grid;
    QValueList<KeyButton *> keys;
    QDomDocument doc;
    QStringList modifiers;
protected:
    void init();
    void layout();
    void parser(const QString &xml);
    void setTableFile(const QString &xml);
protected slots:
    void pressed(const QString &name,const QString &modifier);
    void released(const QString &name,const QString &modifier);
signals:
    void pressed(const QString &event);
    void released(const QString &event);
    void status(const QString &s);
};

#endif
